Subject: Re: bug#60897: 29.0.60; vc-revert fails to revert buffer

From: Eli Zaretskii <[email-masked]>
Date: Mon, 23 Jan 2023 15:24:05 +0200

> From: Juri Linkov <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Mon, 23 Jan 2023 09:51:30 +0200
> 
> >> >  (defun vc-resynch-buffer (file &optional keep noquery reset-vc-info)
> >> >    "If FILE is currently visited, resynch its buffer."
> >> > +  (unless (file-name-absolute-p file)
> >> > +    (setq file (expand-file-name file (vc-root-dir))))
> >> >    (if (string= buffer-file-name file)
> >> >        (vc-resynch-window file keep noquery reset-vc-info)
> >> >      (if (file-directory-p file)
> >> 
> >> Eli, is this ok for the emacs-29 branch?  I'm unsure because
> >> vc-resynch-buffer is used in too many places, so this change
> >> is not localized to vc-revert.
> >
> > You could use the expanded file name only for the purposes of the
> > string= call, no?  Then the effect of this change would be very local
> > and thus safer.
> 
> There is another string= call that fails inside vc-resynch-window
> called from vc-resynch-buffer.

How about replacing string= in these two cases with something smarter,
which would expand-file-name?  Comparing file names as simple strings
is wrought with trouble anyway.